/****************************************************************************/
/*                                                                          */
/*                   Copyright 2003 University of Glasgow                   */
/*                                                                          */
/*                           All rights reserved.                           */
/*                                                                          */
/****************************************************************************/

/****************************************************************************/
/* FILE          : FunEntry.java                                            */
/* DESCRIPTION   : Environment entry for a function                         */
/*                                                                          */
/* AUTHOR        : S.J.Gay                                                  */
/* DATE          : 28th August 2003                                         */
/*                                                                          */
/* LAST MODIFIED : S.J.Gay                                                  */
/* DATE          : 28th August 2003                                         */
/****************************************************************************/

package sfl.env;

import sfl.node.*;
import sfl.types.*;
import java.io.*;

public class FunEntry extends EnvEntry {

    Type resultType;
    int arity;
    String[] argName;
    Type[] argType;

    public FunEntry(Type r, int a, String[] an, Type[] at) {
	resultType = r;
	arity = a;
	argName = an;
	argType = at;
    }

    public Type getResultType() {
	return resultType;
    }

    public int getArity() {
	return arity;
    }

    public String getArgName(int i) {
	return argName[i];
    }

    public Type getArgType(int i) {
	return argType[i];
    }
}
