/****************************************************************************/
/*                                                                          */
/*                   Copyright 2003 University of Glasgow                   */
/*                                                                          */
/*                           All rights reserved.                           */
/*                                                                          */
/****************************************************************************/

/****************************************************************************/
/* FILE          : WrongArgTypeError.java                                   */
/* DESCRIPTION   : Error: wrong type of argument to function                */
/*                                                                          */
/* AUTHOR        : S.J.Gay                                                  */
/* DATE          : 17th September 2003                                      */
/*                                                                          */
/* LAST MODIFIED : S.J.Gay                                                  */
/* DATE          : 17th September 2003                                      */
/****************************************************************************/

package sfl.error;

public class WrongArgTypeError extends Error {

    public String id;
    public Integer position;
    public String formal;
    public String actual;

    public WrongArgTypeError(String i, int p, String f, String a) {
	id = i;
	position = new Integer(p);
	formal = f;
	actual = a;
    }

    public String message() {
	return "the function \"" + id + "\" expects type " + formal +
	    " for argument " + position.toString() + " but type " + actual +
	    " has been supplied";
    } 

}
