/****************************************************************************/
/*                                                                          */
/*                   Copyright 2003 University of Glasgow                   */
/*                                                                          */
/*                           All rights reserved.                           */
/*                                                                          */
/****************************************************************************/

/****************************************************************************/
/* FILE          : WrongNumArgsError.java                                   */
/* DESCRIPTION   : Error: wrong number of arguments to function             */
/*                                                                          */
/* AUTHOR        : S.J.Gay                                                  */
/* DATE          : 17th September 2003                                      */
/*                                                                          */
/* LAST MODIFIED : S.J.Gay                                                  */
/* DATE          : 17th September 2003                                      */
/****************************************************************************/

package sfl.error;

public class WrongNumArgsError extends Error {

    public String id;
    public Integer formalArity;
    public Integer actualArity;

    public WrongNumArgsError(String i, int fa, int aa) {
	id = i;
	formalArity = new Integer(fa);
	actualArity = new Integer(aa);
    }

    public String message() {
	return "the function \"" + id + "\" expects " + 
	    formalArity.toString() + " arguments but " + 
	    actualArity.toString() + " have been supplied";
    } 

}
