/* This file was generated by SableCC (http://www.sablecc.org/). */

package sfl.parser;

import sfl.lexer.*;
import sfl.node.*;
import sfl.analysis.*;
import java.util.*;

import java.io.DataInputStream;
import java.io.BufferedInputStream;
import java.io.IOException;

public class Parser
{
    public final Analysis ignoredTokens = new AnalysisAdapter();

    protected Node node;

    private final Lexer lexer;
    private final ListIterator stack = new LinkedList().listIterator();
    private int last_shift;
    private int last_pos;
    private int last_line;
    private Token last_token;
    private final TokenIndex converter = new TokenIndex();
    private final int[] action = new int[2];

    private final static int SHIFT = 0;
    private final static int REDUCE = 1;
    private final static int ACCEPT = 2;
    private final static int ERROR = 3;

    protected void filter() throws ParserException, LexerException, IOException
    {
    }

    public Parser(Lexer lexer)
    {
        this.lexer = lexer;

        if(actionTable == null)
        {
            try
            {
                DataInputStream s = new DataInputStream(
                    new BufferedInputStream(
                    Parser.class.getResourceAsStream("parser.dat")));

                // read actionTable
                int length = s.readInt();
                actionTable = new int[length][][];
                for(int i = 0; i < actionTable.length; i++)
                {
                    length = s.readInt();
                    actionTable[i] = new int[length][3];
                    for(int j = 0; j < actionTable[i].length; j++)
                    {
                        for(int k = 0; k < 3; k++)
                        {
                            actionTable[i][j][k] = s.readInt();
                        }
                    }
                }

                // read gotoTable
                length = s.readInt();
                gotoTable = new int[length][][];
                for(int i = 0; i < gotoTable.length; i++)
                {
                    length = s.readInt();
                    gotoTable[i] = new int[length][2];
                    for(int j = 0; j < gotoTable[i].length; j++)
                    {
                        for(int k = 0; k < 2; k++)
                        {
                            gotoTable[i][j][k] = s.readInt();
                        }
                    }
                }

                // read errorMessages
                length = s.readInt();
                errorMessages = new String[length];
                for(int i = 0; i < errorMessages.length; i++)
                {
                    length = s.readInt();
                    StringBuffer buffer = new StringBuffer();

                    for(int j = 0; j < length; j++)
                    {
                        buffer.append(s.readChar());
                    }
                    errorMessages[i] = buffer.toString();
                }

                // read errors
                length = s.readInt();
                errors = new int[length];
                for(int i = 0; i < errors.length; i++)
                {
                    errors[i] = s.readInt();
                }

                s.close();
            }
            catch(Exception e)
            {
                throw new RuntimeException("The file \"parser.dat\" is either missing or corrupted.");
            }
        }
    }

    private int goTo(int index)
    {
        int state = state();
        int low = 1;
        int high = gotoTable[index].length - 1;
        int value = gotoTable[index][0][1];

        while(low <= high)
        {
            int middle = (low + high) / 2;

            if(state < gotoTable[index][middle][0])
            {
                high = middle - 1;
            }
            else if(state > gotoTable[index][middle][0])
            {
                low = middle + 1;
            }
            else
            {
                value = gotoTable[index][middle][1];
                break;
            }
        }

        return value;
    }

    private void push(int state, Node node, boolean filter) throws ParserException, LexerException, IOException
    {
        this.node = node;

        if(filter)
        {
            filter();
        }

        if(!stack.hasNext())
        {
            stack.add(new State(state, this.node));
            return;
        }

        State s = (State) stack.next();
        s.state = state;
        s.node = this.node;
    }

    private int state()
    {
        State s = (State) stack.previous();
        stack.next();
        return s.state;
    }

    private Node pop()
    {
        return (Node) ((State) stack.previous()).node;
    }

    private int index(Switchable token)
    {
        converter.index = -1;
        token.apply(converter);
        return converter.index;
    }

    public Start parse() throws ParserException, LexerException, IOException
    {
        push(0, null, false);

        List ign = null;
        while(true)
        {
            while(index(lexer.peek()) == -1)
            {
                if(ign == null)
                {
                    ign = new TypedLinkedList(NodeCast.instance);
                }

                ign.add(lexer.next());
            }

            if(ign != null)
            {
                ignoredTokens.setIn(lexer.peek(), ign);
                ign = null;
            }

            last_pos = lexer.peek().getPos();
            last_line = lexer.peek().getLine();
            last_token = lexer.peek();

            int index = index(lexer.peek());
            action[0] = actionTable[state()][0][1];
            action[1] = actionTable[state()][0][2];

            int low = 1;
            int high = actionTable[state()].length - 1;

            while(low <= high)
            {
                int middle = (low + high) / 2;

                if(index < actionTable[state()][middle][0])
                {
                    high = middle - 1;
                }
                else if(index > actionTable[state()][middle][0])
                {
                    low = middle + 1;
                }
                else
                {
                    action[0] = actionTable[state()][middle][1];
                    action[1] = actionTable[state()][middle][2];
                    break;
                }
            }

            switch(action[0])
            {
                case SHIFT:
                    push(action[1], lexer.next(), true);
                    last_shift = action[1];
                    break;
                case REDUCE:
                    switch(action[1])
                    {
                    case 0: { Node node = new0(); push(goTo(0), node, true); } break;
                    case 1: { Node node = new1(); push(goTo(0), node, true); } break;
                    case 2: { Node node = new2(); push(goTo(11), node, false); } break;
                    case 3: { Node node = new3(); push(goTo(11), node, false); } break;
                    case 4: { Node node = new4(); push(goTo(1), node, true); } break;
                    case 5: { Node node = new5(); push(goTo(1), node, true); } break;
                    case 6: { Node node = new6(); push(goTo(1), node, true); } break;
                    case 7: { Node node = new7(); push(goTo(1), node, true); } break;
                    case 8: { Node node = new8(); push(goTo(1), node, true); } break;
                    case 9: { Node node = new9(); push(goTo(2), node, true); } break;
                    case 10: { Node node = new10(); push(goTo(3), node, true); } break;
                    case 11: { Node node = new11(); push(goTo(3), node, true); } break;
                    case 12: { Node node = new12(); push(goTo(3), node, true); } break;
                    case 13: { Node node = new13(); push(goTo(3), node, true); } break;
                    case 14: { Node node = new14(); push(goTo(3), node, true); } break;
                    case 15: { Node node = new15(); push(goTo(3), node, true); } break;
                    case 16: { Node node = new16(); push(goTo(4), node, true); } break;
                    case 17: { Node node = new17(); push(goTo(4), node, true); } break;
                    case 18: { Node node = new18(); push(goTo(12), node, false); } break;
                    case 19: { Node node = new19(); push(goTo(12), node, false); } break;
                    case 20: { Node node = new20(); push(goTo(5), node, true); } break;
                    case 21: { Node node = new21(); push(goTo(5), node, true); } break;
                    case 22: { Node node = new22(); push(goTo(6), node, true); } break;
                    case 23: { Node node = new23(); push(goTo(6), node, true); } break;
                    case 24: { Node node = new24(); push(goTo(7), node, true); } break;
                    case 25: { Node node = new25(); push(goTo(7), node, true); } break;
                    case 26: { Node node = new26(); push(goTo(8), node, true); } break;
                    case 27: { Node node = new27(); push(goTo(8), node, true); } break;
                    case 28: { Node node = new28(); push(goTo(13), node, false); } break;
                    case 29: { Node node = new29(); push(goTo(13), node, false); } break;
                    case 30: { Node node = new30(); push(goTo(9), node, true); } break;
                    case 31: { Node node = new31(); push(goTo(10), node, true); } break;
                    }
                    break;
                case ACCEPT:
                    {
                        EOF node2 = (EOF) lexer.next();
                        PProgram node1 = (PProgram) pop();
                        Start node = new Start(node1, node2);
                        return node;
                    }
                case ERROR:
                    throw new ParserException(last_token,
                        "[" + last_line + "," + last_pos + "] " +
                        errorMessages[errors[action[1]]]);
            }
        }
    }

    Node new0()
    {
        PExpression node2 = (PExpression) pop();
        XPFunDef node1 = null;
        AProgram node = new AProgram(node1, node2);
        return node;
    }

    Node new1()
    {
        PExpression node2 = (PExpression) pop();
        XPFunDef node1 = (XPFunDef) pop();
        AProgram node = new AProgram(node1, node2);
        return node;
    }

    Node new2()
    {
        PFunDef node2 = (PFunDef) pop();
        XPFunDef node1 = (XPFunDef) pop();
        X1PFunDef node = new X1PFunDef(node1, node2);
        return node;
    }

    Node new3()
    {
        PFunDef node1 = (PFunDef) pop();
        X2PFunDef node = new X2PFunDef(node1);
        return node;
    }

    Node new4()
    {
        PTerm node1 = (PTerm) pop();
        ATermExpression node = new ATermExpression(node1);
        return node;
    }

    Node new5()
    {
        PTerm node3 = (PTerm) pop();
        TPlus node2 = (TPlus) pop();
        PTerm node1 = (PTerm) pop();
        APlusExpression node = new APlusExpression(node1, node2, node3);
        return node;
    }

    Node new6()
    {
        PTerm node3 = (PTerm) pop();
        TAnd node2 = (TAnd) pop();
        PTerm node1 = (PTerm) pop();
        AAndExpression node = new AAndExpression(node1, node2, node3);
        return node;
    }

    Node new7()
    {
        PTerm node3 = (PTerm) pop();
        TEq node2 = (TEq) pop();
        PTerm node1 = (PTerm) pop();
        AEqExpression node = new AEqExpression(node1, node2, node3);
        return node;
    }

    Node new8()
    {
        PExpression node6 = (PExpression) pop();
        TElse node5 = (TElse) pop();
        PExpression node4 = (PExpression) pop();
        TThen node3 = (TThen) pop();
        PExpression node2 = (PExpression) pop();
        TIf node1 = (TIf) pop();
        ACondExpression node = new ACondExpression(node1, node2, node3, node4, node5, node6);
        return node;
    }

    Node new9()
    {
        PExpression node2 = (PExpression) pop();
        TComma node1 = (TComma) pop();
        ACommaExpression node = new ACommaExpression(node1, node2);
        return node;
    }

    Node new10()
    {
        TInt node1 = (TInt) pop();
        AIntLitTerm node = new AIntLitTerm(node1);
        return node;
    }

    Node new11()
    {
        PBool node1 = (PBool) pop();
        ABoolLitTerm node = new ABoolLitTerm(node1);
        return node;
    }

    Node new12()
    {
        TId node1 = (TId) pop();
        AIdTerm node = new AIdTerm(node1);
        return node;
    }

    Node new13()
    {
        TRparen node4 = (TRparen) pop();
        PArgs node3 = null;
        TLparen node2 = (TLparen) pop();
        TId node1 = (TId) pop();
        AAppTerm node = new AAppTerm(node1, node2, node3, node4);
        return node;
    }

    Node new14()
    {
        TRparen node4 = (TRparen) pop();
        PArgs node3 = (PArgs) pop();
        TLparen node2 = (TLparen) pop();
        TId node1 = (TId) pop();
        AAppTerm node = new AAppTerm(node1, node2, node3, node4);
        return node;
    }

    Node new15()
    {
        TRparen node3 = (TRparen) pop();
        PExpression node2 = (PExpression) pop();
        TLparen node1 = (TLparen) pop();
        AExpTerm node = new AExpTerm(node1, node2, node3);
        return node;
    }

    Node new16()
    {
        XPCommaExpression node2 = null;
        PExpression node1 = (PExpression) pop();
        AArgs node = new AArgs(node1, node2);
        return node;
    }

    Node new17()
    {
        XPCommaExpression node2 = (XPCommaExpression) pop();
        PExpression node1 = (PExpression) pop();
        AArgs node = new AArgs(node1, node2);
        return node;
    }

    Node new18()
    {
        PCommaExpression node2 = (PCommaExpression) pop();
        XPCommaExpression node1 = (XPCommaExpression) pop();
        X1PCommaExpression node = new X1PCommaExpression(node1, node2);
        return node;
    }

    Node new19()
    {
        PCommaExpression node1 = (PCommaExpression) pop();
        X2PCommaExpression node = new X2PCommaExpression(node1);
        return node;
    }

    Node new20()
    {
        TTrue node1 = (TTrue) pop();
        ATrueBool node = new ATrueBool(node1);
        return node;
    }

    Node new21()
    {
        TFalse node1 = (TFalse) pop();
        AFalseBool node = new AFalseBool(node1);
        return node;
    }

    Node new22()
    {
        TIntTy node1 = (TIntTy) pop();
        AIntTy node = new AIntTy(node1);
        return node;
    }

    Node new23()
    {
        TBoolTy node1 = (TBoolTy) pop();
        ABoolTy node = new ABoolTy(node1);
        return node;
    }

    Node new24()
    {
        TSemi node9 = (TSemi) pop();
        PExpression node8 = (PExpression) pop();
        TIs node7 = (TIs) pop();
        PTy node6 = (PTy) pop();
        TColon node5 = (TColon) pop();
        TRparen node4 = (TRparen) pop();
        PTypedArgs node3 = null;
        TLparen node2 = (TLparen) pop();
        TId node1 = (TId) pop();
        AFunDef node = new AFunDef(node1, node2, node3, node4, node5, node6, node7, node8, node9);
        return node;
    }

    Node new25()
    {
        TSemi node9 = (TSemi) pop();
        PExpression node8 = (PExpression) pop();
        TIs node7 = (TIs) pop();
        PTy node6 = (PTy) pop();
        TColon node5 = (TColon) pop();
        TRparen node4 = (TRparen) pop();
        PTypedArgs node3 = (PTypedArgs) pop();
        TLparen node2 = (TLparen) pop();
        TId node1 = (TId) pop();
        AFunDef node = new AFunDef(node1, node2, node3, node4, node5, node6, node7, node8, node9);
        return node;
    }

    Node new26()
    {
        XPCommaTypedArg node2 = null;
        PTypedArg node1 = (PTypedArg) pop();
        ATypedArgs node = new ATypedArgs(node1, node2);
        return node;
    }

    Node new27()
    {
        XPCommaTypedArg node2 = (XPCommaTypedArg) pop();
        PTypedArg node1 = (PTypedArg) pop();
        ATypedArgs node = new ATypedArgs(node1, node2);
        return node;
    }

    Node new28()
    {
        PCommaTypedArg node2 = (PCommaTypedArg) pop();
        XPCommaTypedArg node1 = (XPCommaTypedArg) pop();
        X1PCommaTypedArg node = new X1PCommaTypedArg(node1, node2);
        return node;
    }

    Node new29()
    {
        PCommaTypedArg node1 = (PCommaTypedArg) pop();
        X2PCommaTypedArg node = new X2PCommaTypedArg(node1);
        return node;
    }

    Node new30()
    {
        PTy node3 = (PTy) pop();
        TColon node2 = (TColon) pop();
        TId node1 = (TId) pop();
        ATypedArg node = new ATypedArg(node1, node2, node3);
        return node;
    }

    Node new31()
    {
        PTypedArg node2 = (PTypedArg) pop();
        TComma node1 = (TComma) pop();
        ACommaTypedArg node = new ACommaTypedArg(node1, node2);
        return node;
    }

    private static int[][][] actionTable;
/*      {
			{{-1, ERROR, 0}, {0, SHIFT, 1}, {4, SHIFT, 2}, {8, SHIFT, 3}, {9, SHIFT, 4}, {12, SHIFT, 5}, {17, SHIFT, 6}, },
			{{-1, REDUCE, 10}, },
			{{-1, ERROR, 2}, {0, SHIFT, 1}, {4, SHIFT, 2}, {8, SHIFT, 3}, {9, SHIFT, 4}, {12, SHIFT, 5}, {17, SHIFT, 13}, },
			{{-1, REDUCE, 20}, },
			{{-1, REDUCE, 21}, },
			{{-1, ERROR, 5}, {0, SHIFT, 1}, {4, SHIFT, 2}, {8, SHIFT, 3}, {9, SHIFT, 4}, {12, SHIFT, 5}, {17, SHIFT, 13}, },
			{{-1, REDUCE, 12}, {12, SHIFT, 16}, },
			{{-1, ERROR, 7}, {18, ACCEPT, -1}, },
			{{-1, REDUCE, 0}, },
			{{-1, REDUCE, 4}, {1, SHIFT, 17}, {2, SHIFT, 18}, {3, SHIFT, 19}, },
			{{-1, REDUCE, 11}, },
			{{-1, REDUCE, 3}, },
			{{-1, ERROR, 12}, {0, SHIFT, 1}, {4, SHIFT, 2}, {8, SHIFT, 3}, {9, SHIFT, 4}, {12, SHIFT, 5}, {17, SHIFT, 6}, },
			{{-1, REDUCE, 12}, {12, SHIFT, 22}, },
			{{-1, ERROR, 14}, {5, SHIFT, 23}, },
			{{-1, ERROR, 15}, {13, SHIFT, 24}, },
			{{-1, ERROR, 16}, {0, SHIFT, 1}, {4, SHIFT, 2}, {8, SHIFT, 3}, {9, SHIFT, 4}, {12, SHIFT, 5}, {13, SHIFT, 25}, {17, SHIFT, 26}, },
			{{-1, ERROR, 17}, {0, SHIFT, 1}, {8, SHIFT, 3}, {9, SHIFT, 4}, {12, SHIFT, 5}, {17, SHIFT, 13}, },
			{{-1, ERROR, 18}, {0, SHIFT, 1}, {8, SHIFT, 3}, {9, SHIFT, 4}, {12, SHIFT, 5}, {17, SHIFT, 13}, },
			{{-1, ERROR, 19}, {0, SHIFT, 1}, {8, SHIFT, 3}, {9, SHIFT, 4}, {12, SHIFT, 5}, {17, SHIFT, 13}, },
			{{-1, REDUCE, 1}, },
			{{-1, REDUCE, 2}, },
			{{-1, ERROR, 22}, {0, SHIFT, 1}, {4, SHIFT, 2}, {8, SHIFT, 3}, {9, SHIFT, 4}, {12, SHIFT, 5}, {13, SHIFT, 34}, {17, SHIFT, 13}, },
			{{-1, ERROR, 23}, {0, SHIFT, 1}, {4, SHIFT, 2}, {8, SHIFT, 3}, {9, SHIFT, 4}, {12, SHIFT, 5}, {17, SHIFT, 13}, },
			{{-1, REDUCE, 15}, },
			{{-1, REDUCE, 13}, {15, SHIFT, 36}, },
			{{-1, REDUCE, 12}, {12, SHIFT, 22}, {15, SHIFT, 37}, },
			{{-1, REDUCE, 16}, {14, SHIFT, 38}, },
			{{-1, ERROR, 28}, {13, SHIFT, 41}, },
			{{-1, ERROR, 29}, {13, SHIFT, 42}, },
			{{-1, REDUCE, 26}, {14, SHIFT, 43}, },
			{{-1, REDUCE, 5}, },
			{{-1, REDUCE, 6}, },
			{{-1, REDUCE, 7}, },
			{{-1, REDUCE, 13}, },
			{{-1, ERROR, 35}, {6, SHIFT, 46}, },
			{{-1, ERROR, 36}, {10, SHIFT, 47}, {11, SHIFT, 48}, },
			{{-1, ERROR, 37}, {10, SHIFT, 47}, {11, SHIFT, 48}, },
			{{-1, ERROR, 38}, {0, SHIFT, 1}, {4, SHIFT, 2}, {8, SHIFT, 3}, {9, SHIFT, 4}, {12, SHIFT, 5}, {17, SHIFT, 13}, },
			{{-1, REDUCE, 19}, },
			{{-1, REDUCE, 17}, {14, SHIFT, 38}, },
			{{-1, REDUCE, 14}, },
			{{-1, ERROR, 42}, {15, SHIFT, 53}, },
			{{-1, ERROR, 43}, {17, SHIFT, 54}, },
			{{-1, REDUCE, 29}, },
			{{-1, REDUCE, 27}, {14, SHIFT, 43}, },
			{{-1, ERROR, 46}, {0, SHIFT, 1}, {4, SHIFT, 2}, {8, SHIFT, 3}, {9, SHIFT, 4}, {12, SHIFT, 5}, {17, SHIFT, 13}, },
			{{-1, REDUCE, 22}, },
			{{-1, REDUCE, 23}, },
			{{-1, ERROR, 49}, {7, SHIFT, 58}, },
			{{-1, REDUCE, 30}, },
			{{-1, REDUCE, 9}, },
			{{-1, REDUCE, 18}, },
			{{-1, ERROR, 53}, {10, SHIFT, 47}, {11, SHIFT, 48}, },
			{{-1, ERROR, 54}, {15, SHIFT, 37}, },
			{{-1, REDUCE, 31}, },
			{{-1, REDUCE, 28}, },
			{{-1, REDUCE, 8}, },
			{{-1, ERROR, 58}, {0, SHIFT, 1}, {4, SHIFT, 2}, {8, SHIFT, 3}, {9, SHIFT, 4}, {12, SHIFT, 5}, {17, SHIFT, 13}, },
			{{-1, ERROR, 59}, {7, SHIFT, 61}, },
			{{-1, ERROR, 60}, {16, SHIFT, 62}, },
			{{-1, ERROR, 61}, {0, SHIFT, 1}, {4, SHIFT, 2}, {8, SHIFT, 3}, {9, SHIFT, 4}, {12, SHIFT, 5}, {17, SHIFT, 13}, },
			{{-1, REDUCE, 24}, },
			{{-1, ERROR, 63}, {16, SHIFT, 64}, },
			{{-1, REDUCE, 25}, },
        };*/
    private static int[][][] gotoTable;
/*      {
			{{-1, 7}, },
			{{-1, 27}, {0, 8}, {2, 14}, {5, 15}, {12, 20}, {23, 35}, {38, 51}, {46, 57}, {58, 60}, {61, 63}, },
			{{-1, 39}, {40, 52}, },
			{{-1, 9}, {17, 31}, {18, 32}, {19, 33}, },
			{{-1, 28}, },
			{{-1, 10}, },
			{{-1, 49}, {37, 50}, {53, 59}, },
			{{-1, 11}, {12, 21}, },
			{{-1, 29}, },
			{{-1, 30}, {43, 55}, },
			{{-1, 44}, {45, 56}, },
			{{-1, 12}, },
			{{-1, 40}, },
			{{-1, 45}, },
        };*/
    private static String[] errorMessages;
/*      {
			"expecting: int, 'if', 'true', 'false', '(', id",
			"expecting: '+', '&', '==', 'then', 'else', ')', ',', ';', EOF",
			"expecting: '+', '&', '==', '(', EOF",
			"expecting: EOF",
			"expecting: '+', '&', '==', 'then', 'else', '(', ')', ',', ';', EOF",
			"expecting: 'then'",
			"expecting: ')'",
			"expecting: int, 'if', 'true', 'false', '(', ')', id",
			"expecting: int, 'true', 'false', '(', id",
			"expecting: '+', '&', '==', ':', EOF",
			"expecting: '+', '&', '==', '(', ')', ',', ':'",
			"expecting: ')', ','",
			"expecting: 'then', 'else', ')', ',', ';', EOF",
			"expecting: 'else'",
			"expecting: 'int', 'bool'",
			"expecting: ':'",
			"expecting: id",
			"expecting: 'is', ')', ','",
			"expecting: 'is'",
			"expecting: ';'",
        };*/
    private static int[] errors;
/*      {
			0, 1, 0, 1, 1, 0, 2, 3, 3, 1, 1, 0, 0, 4, 5, 6, 7, 8, 8, 8, 3, 0, 7, 0, 1, 9, 10, 11, 6, 6, 11, 12, 12, 12, 1, 13, 14, 14, 0, 11, 11, 1, 15, 16, 11, 11, 0, 17, 17, 18, 11, 11, 11, 14, 15, 11, 11, 12, 0, 18, 19, 0, 0, 19, 0, 
        };*/
}
